#include <stdio.h>

static char alpha[]={'a','b','c','d','e','f','g','h','i','j','k',
		     'l','m','n','o','p','q','r','s','t','u','v','w',
                     'x','y','z'}; 
int 
main(argc,argv)
int argc;
char *argv[];
{
  int i,j,nfile,nread;
  char *filename,*data;
  FILE *fptr,*fout;
  char outfilename[80],stemp[20];
  unsigned long kbytes,filesize,outfilesize,readsize;
  
  /* usage notice */
  if (argc != 3) {
    printf("Usage: %s filename kbytes\n",argv[0]);
    printf("       filename is the name of the large file.\n");
    printf("       kbytes is the number of KB per splited file.\n");
    exit(1);
  }
  filename=argv[1];
  kbytes=(unsigned long)atoi(argv[2]);

  /* check how many pieces */
  fptr=fopen(filename,"r");
  if (fptr == NULL) {
    printf("Cannot open the file: %s\n",filename);
    exit(2);
  }

  fseek(fptr,0,2);
  filesize=ftell(fptr)/1024+1;
  if (filesize < kbytes) {
    printf("File size (%dKB) is smaller than what you want to split (%dKB)\n",
	   filesize,kbytes);
    exit(2);
  }

  nfile=filesize/kbytes+1;
  if (nfile > 26*26) {
    printf("Exceed the maximum number of files (%d > %d)",nfile,26*26);
    exit(2);
  }

  data=(char *)malloc(64*1024*sizeof(char));
  if (data == NULL) {
    printf("Not enough memeory! You need at least 60KB RAM \n");
    exit(1);
  }
  fseek(fptr,0,0);
  for (i=0; i < nfile; i++) {
    if (i == nfile -1) 
      outfilesize=filesize-(nfile-1)*kbytes;
    else
      outfilesize=kbytes;
    if (outfilesize > 0) {
      if (nfile < 27) 
	sprintf(outfilename,"%c_%s",alpha[i],filename);
      else 
	sprintf(outfilename,"%c%c_%s",alpha[i%26],alpha[i/26],filename);
      fout=fopen(outfilename,"r");
      if (fout != NULL) {
	printf("File %s exits, overwrite it? (Y/N)",outfilename);
	gets(stemp);
	if (strncasecmp(stemp,"y",1) != 0) 
	  exit(3);
	else 
	  fclose(fout);
      }
      fout=fopen(outfilename,"w");
      nread=outfilesize/64+1;
      readsize=64*1024;
      for (j=0; i < (nread-1); j++) {
	fread(data,sizeof(char),readsize,fptr);
	fwrite(data,sizeof(char),readsize,fout);
      }
      readsize=(outfilesize-(nread-1)*64)*1024;
      if (readsize > 0) {
	fread(data,sizeof(char),readsize,fptr);
	fwrite(data,sizeof(char),readsize,fout);
      }
      fclose(fout);
    }
  }
  fclose(fptr);
}



